/*
Language: JSON
Author: Ivan Sagalaev <maniac@softwaremaniacs.org>
Category: common, protocols
*/
import * as tslib_1 from "tslib";
import { QUOTE_STRING_MODE, C_NUMBER_MODE, BACKSLASH_ESCAPE } from '../common';
var LITERALS = { literal: 'true false null' };
var TYPES = [
    QUOTE_STRING_MODE,
    C_NUMBER_MODE
];
var VALUE_CONTAINER = {
    end: ',', endsWithParent: true, excludeEnd: true,
    contains: TYPES,
    keywords: LITERALS
};
var OBJECT = {
    begin: '{', end: '}',
    contains: [
        {
            className: 'attr',
            begin: /"/, end: /"/,
            contains: [BACKSLASH_ESCAPE],
            illegal: '\\n',
        },
        tslib_1.__assign({}, VALUE_CONTAINER, { begin: /:/ })
    ],
    illegal: '\\S'
};
var ARRAY = {
    begin: '\\[', end: '\\]',
    contains: [tslib_1.__assign({}, VALUE_CONTAINER)],
    illegal: '\\S'
};
TYPES.splice(TYPES.length, 0, OBJECT, ARRAY);
export var JSON = {
    name: 'json',
    contains: TYPES,
    keywords: LITERALS,
    illegal: '\\S'
};
//# sourceMappingURL=json.js.map