import { Options, Renderer, LanguageName, CompiledLanguageDef, Result } from './types';
export interface Content<Output> {
    className?: string;
    content: Output[];
}
export declare function highlight<Output>(options: Options, render: Renderer<Output>, lang: LanguageName, value: string, ignore_illegals: boolean, continuation?: CompiledLanguageDef): Result<Output>;
export declare function highlightAuto<Output>(options: Options, render: Renderer<Output>, text: string, languageSubset?: LanguageName[]): Result<Output>;
export declare function fixMarkup(options: Options, value: string): string;
export declare const defaults: Options;
export interface Highlighter<Output> {
    render: Renderer<Output>;
    options: Options;
}
export declare function init<Output>(render: Renderer<Output>, options?: Partial<Options>): Highlighter<Output>;
export declare function process<Output>({render, options}: Highlighter<Output>, source: string, lang?: LanguageName | LanguageName[]): Result<Output>;
