"use strict";
/*
Language: Dockerfile
Requires: bash.js
Author: Alexis Hénaut <alexis@henaut.net>
Description: language definition for Dockerfile files
Category: config
*/
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
exports.Dockerfile = {
    name: 'dockerfile',
    aliases: ['docker'],
    case_insensitive: true,
    keywords: 'from maintainer expose env arg user onbuild stopsignal',
    contains: [
        common_1.HASH_COMMENT_MODE,
        common_1.APOS_STRING_MODE,
        common_1.QUOTE_STRING_MODE,
        common_1.NUMBER_MODE,
        {
            beginKeywords: 'run cmd entrypoint volume add copy workdir label healthcheck shell',
            starts: {
                end: /[^\\]\n/,
                subLanguage: 'bash'
            }
        }
    ],
    illegal: '</'
};
//# sourceMappingURL=dockerfile.js.map